// bits ripped off from various components

// OnValidate not correct because when editor is active, grid never gets sent
// CM_exit message - message goes to editor but not parent grid.

unit MyStrGrid;

interface

uses
  { Borland }
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, Menus,
  { Mine }
  Str_Util;

type
  TValidateEvent = procedure( Sender:TObject; var Value:String;
                              var Validate:boolean; ACol,ARow:LongInt) of object;

type
  My_str_grid = class(TStringGrid)
  public
    constructor Create(AOwner: TComponent); override;
    procedure   InitValidate; {Call this func to avoid Onvalidate in beginning}
  private
    { Private declarations }
    FModified                : boolean;
    ModifyFlag               : boolean;
    OldCol,OldRow            : LongInt;
    OldCellText,ValidateText : String;
    FOnValidate              : TValidateEvent;
    storedpopup              : TPopUpMenu;

    procedure CMEnter(var Message: TCMEnter); message CM_ENTER;
    procedure CMExit(var Message: TCMExit); message CM_EXIT;
  protected
    procedure MouseDown(Button:TMouseButton; Shift:TShiftState; X,Y:Integer); override;
    procedure Click;override;
    procedure KeyPress(var Key: Char); override;
  public
    EnterFlag,ValidateFlag   : boolean;
    procedure Show_Editor;
    procedure Hide_Editor;
    function  ModifyRow(which:integer; contents,delimiter:string):integer;
    procedure LoadFromPchar(pc:Pchar; ColSep:string);
    function  SaveToPchar(ColSep:string; fixed,break_on_blank:boolean) : Pchar;
    property  Modified : boolean read FModified write FModified;
    procedure ClearValidationFlag;
    function EditorText : string;
    function Editor : TInplaceEdit;
  published
    { Published declarations }
    property  OnValidate : TValidateEvent read FOnValidate write FOnValidate;
  end;

procedure Register;

implementation

///////////////////////////////////////////////////////////////////////////////
// My_str_grid,
///////////////////////////////////////////////////////////////////////////////
constructor My_str_grid.Create(AOwner: TComponent);
begin
   {invoke parent method}
   inherited Create(AOwner);
   {myself constructor}
   ModifyFlag  := False;
   EnterFlag   := False;
   OldCellText := '';
   InitValidate;
end;

// We want a popupmenu for the grid, nut still to have the cut/copy/paste menu
// when the editor is active
procedure My_str_grid.MouseDown(Button:TMouseButton; Shift:TShiftState; X,Y:Integer);
begin                       
  inherited;
  if EditorMode and (PopUpMenu<>nil) then begin
    storedpopup := PopUpMenu;
    PopUpMenu   := nil;
  end else begin
    if storedpopup<>nil then begin
      popupmenu   := storedpopup;
      storedpopup := nil;
    end;
  end;
//  if Assigned(OnMouseDown) then OnMouseDown(self,Button,Shift,X,Y);
end;

procedure My_str_grid.Click;
begin
   inherited Click;
   {doing my job}
   if OldCellText <> Self.Cells[OldCol,OldRow] then ModifyFlag := True;
   if ModifyFlag then begin
      FModified    := true;
      ModifyFlag   := False;
      ValidateFlag := True;
      try
         ValidateText := Self.Cells[OldCol,OldRow];
         {invoke validate event}
         if Assigned(FOnValidate) then OnValidate(self,ValidateText,ValidateFlag,OldCol,OldRow);
      except
      end;
      {if not Validate then recovery old-text}
      if not ValidateFlag then Self.Cells[OldCol,OldRow] := OldCellText
      else Self.Cells[OldCol,OldRow] := ValidateText;
   end;
   OldCol := Self.Col;
   OldRow := Self.Row;
   OldCellText := Self.Cells[OldCol,OldRow];
end;

procedure My_str_grid.KeyPress(var Key: Char);
var OldKey:Char;
begin
   {inherited}
   OldKey:= Key; {*** prevent Key modified ***}
   inherited KeyPress(Key);

   {doing my job}
   if OldKey=Chr(13) then begin
      if OldCellText <> Self.Cells[OldCol,OldRow] then ModifyFlag := True;
      if ModifyFlag then begin
         FModified    := true;
         ModifyFlag   := False;
         ValidateFlag := True;
         try
            ValidateText := Self.Cells[OldCol,OldRow];
            {invoke validate event}
         if Assigned(FOnValidate) then OnValidate(self,ValidateText,ValidateFlag,OldCol,OldRow);
         except
         end;
         {if not Validate then recovery old-text}
         if not ValidateFlag then Self.Cells[OldCol,OldRow] := OldCellText
         else Self.Cells[OldCol,OldRow] := ValidateText;
      end;
      OldCol := Self.Col;
      OldRow := Self.Row;
      OldCellText := Self.Cells[OldCol,OldRow];
   end;
end;

procedure My_str_grid.CMEnter(var Message: TCMEnter);
begin
  inherited;
   ModifyFlag  := False;
   OldCol      := Self.Col;
   OldRow      := Self.Row;
   OldCellText := Self.Cells[OldCol,OldRow];
   EnterFlag   := True;
end;

procedure My_str_grid.CMExit(var Message: TCMExit);
begin
  inherited;
try
   if not EnterFlag then exit;
   if OldCellText <> Self.Cells[OldCol,OldRow] then ModifyFlag := True;
   if ModifyFlag then begin
      FModified    := true;
      ModifyFlag   := False;
      ValidateFlag := True;
      try
         ValidateText := Self.Cells[OldCol,OldRow];
         {invoke validate event}
         if Assigned(FOnValidate) then OnValidate(self,ValidateText,ValidateFlag,OldCol,OldRow);
      except
      end;
      {if not Validate then recovery old-text}
      if not ValidateFlag then Self.Cells[OldCol,OldRow] := OldCellText
      else Self.Cells[OldCol,OldRow] := ValidateText;
   end;

finally
  EnterFlag   := False;
  OldCol      := Self.Col;
  OldRow      := Self.Row;
  OldCellText := Self.Cells[OldCol,OldRow];
//  SetCursor(0);
  DoExit;
end;

end;

procedure My_str_grid.InitValidate;
begin
   ModifyFlag  := False;
   OldCol      := self.Col;
   OldRow      := self.Row;
   OldCellText := self.Cells[OldCol,OldRow];
   EnterFlag   := True;
end;

// Fix for clear Grid contents to stop old value being replaced
procedure My_str_grid.ClearValidationFlag;
begin
  ValidateFlag := false;
  OldCellText := '';
end;

function My_str_grid.ModifyRow(which:integer; contents,delimiter:string):integer;
var p,c,len:integer;
begin c:=0;
      len:=length(delimiter)-1;
      repeat p:=pos(delimiter,contents);
             if p=0 then break;
             cells[c,which]:=copy(contents,1,p-1);
             system.delete(contents,1,p+len);
             inc(c)
      until false;
      cells[c,which]:=contents;
      ModifyRow:=c+1
end;

procedure My_str_grid.LoadFromPchar(pc:Pchar; ColSep:string);
var f      : textfile;
    rowstr : string;
    MaxCol : integer;
    r,c    : integer;
    tm     : TMemoryStream;
begin
  tm := TMemoryStream.Create;
  tm.Write(pc^,StrLen(pc)+1);
  tm.position := 0;
  r:=-1;
  MaxCol:=0;
  repeat
    rowstr := read_line(tm);
    if rowstr = '' then break;
    inc(r);
    if r>FixedRows then RowCount:=r+1;
    c:=ModifyRow(r,rowstr,ColSep);
    if c>MaxCol then MaxCol:=c;
  until rowstr='';
  RowCount:=r+1;
  ColCount:=MaxCol;
end;

function My_str_grid.SaveToPchar(ColSep:string; fixed,break_on_blank:boolean) : Pchar;
var tm        : TMemoryStream;
    r,c,start : integer;
begin
  tm := TMemoryStream.Create;
  if fixed then start:=0 else start := FixedRows;
  for r:=start to RowCount-1 do begin
    for c:=0 to ColCount-1 do begin
      if c>0 then tm.write(ColSep[1],1);
      tm.write(cells[c,r][1],length(cells[c,r]));
    end;
    tm.write(#13#10,2);
    if break_on_blank and (cells[0,r]='') then break;
  end;
  tm.write(#0#0,1);
  result := StrNew(tm.Memory);
  tm.free;
end;

procedure My_str_grid.Hide_Editor;
begin
  HideEditor;
end;

procedure My_str_grid.Show_Editor;
begin
  HideEditor;
end;

function My_str_grid.Editor : TInplaceEdit;
begin
  result := InplaceEditor;
end;

function My_str_grid.EditorText : string;
begin
  result := InplaceEditor.Text;
end;
///////////////////////////////////////////////////////////////////////////////
//
///////////////////////////////////////////////////////////////////////////////
procedure Register;
begin
  RegisterComponents('Custom', [My_str_grid]);
end;

end.
