///////////////////////////////////////////////////////////////////////////////
//                                                                           //
//                        Main Zonerings control window                      //
//                             John Biddiscombe                             //
//                           J.Biddiscombe@rl.ac.uk                          //
//                                  Freeware                                 //
//                                                                           //
///////////////////////////////////////////////////////////////////////////////
unit SettingsForm;

interface

uses
  { Borland }
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  ExtCtrls, StdCtrls, Buttons, Dialogs, ComCtrls,
  { Downloaded }
  BorBtns,
  { Mine }
  PalUnit,Thinkbox,Str_Util;

type
  TSettings_Form = class(TForm)
    Panel_00: TPanel;
    Panel_01: TPanel;
    Panel_02: TPanel;
    Panel_10: TPanel;
    Panel_11: TPanel;
    Panel_12: TPanel;
    Panel_13: TPanel;
    Panel_20: TPanel;
    Panel_21: TPanel;
    Panel_22: TPanel;
    Pal_panel: TPanel;

    L_maxZ: TLabel;
    L_vanish: TLabel;
    L_persp: TLabel;
    L_mag: TLabel;
    L_aspect: TLabel;
    L_ampy: TLabel;
    L_freqx: TLabel;
    L_freqy: TLabel;
    L_ampx: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    L_maxsp: TLabel;
    L_minsp: TLabel;
    L_rcrfreq: TLabel;
    L_prob_dens: TLabel;
    d1: TLabel;
    Label8: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label31: TLabel;
    Label32: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label25: TLabel;
    Label4: TLabel;
    Label7: TLabel;
    Label23: TLabel;
    Label28: TLabel;
    Label29: TLabel;
    Label30: TLabel;
    Label34: TLabel;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    Bevel4: TBevel;

// general control
    max_polygons       : TScrollBar;
    vanishing          : TScrollBar;
    perspective        : TScrollBar;
    magnification      : TScrollBar;
    rub_out            : TBorCheck;
    in_out             : TBorCheck;
    hide_cursor        : TBorCheck;
    Screensaver        : TBorCheck;
// Aspect control
    aspect_sync        : TBorCheck;
    aspect_a_x         : TScrollBar;
    aspect_a_y         : TScrollBar;
    aspect_f_x         : TScrollBar;
    aspect_f_y         : TScrollBar;
// rotation control
    no_rotation        : TBorRadio;
    sin_rotation       : TBorRadio;
    ran_rotation       : TBorRadio;
    ampl               : TScrollBar;
    precess            : TScrollBar;
    freq               : TScrollBar;
    max_rot_speed      : TScrollBar;
    min_rot_speed      : TScrollBar;
    rot_ran_per        : TBorRadio;
    rot_ran_ran        : TBorRadio;
    rot_ran_freq       : TScrollBar;
// shape control
    shape_per          : TBorRadio;
    shape_ran          : TBorRadio;
    shape_freq         : TScrollBar;
// motion control
    no_motion          : TBorRadio;
    mouse_motion       : TBorRadio;
    ran_fluid_motion   : TBorRadio;
    ran_jump_motion    : TBorRadio;
    par_motion         : TBorRadio;
    mot_b_damping      : TScrollBar;
    mot_ran_freq       : TScrollBar;
    ran_gaussian       : TBorRadio;
    ran_uniform        : TBorRadio;
    mot_par_a          : TScrollBar;
    mot_par_b          : TScrollBar;
    mot_par_c          : TScrollBar;
    mot_par_d          : TScrollBar;
    mot_par_e          : TScrollBar;
    mot_par_f          : TScrollBar;
// density control
    density1           : TScrollBar;
    density2           : TScrollBar;
    density3           : TScrollBar;
    density4           : TScrollBar;
    density5           : TScrollBar;
    density6           : TScrollBar;
    density7           : TScrollBar;
    density8           : TScrollBar;
    density9           : TScrollBar;
    density10          : TScrollBar;
// draw style
    draw_solid         : TBorRadio;
    draw_vertices      : TBorRadio;
// palette control
    palette_inc        : TScrollBar;
    colour_step        : TScrollBar;
    palette_list       : TListBox;

    PDF_zero           : TButton;
    PDF_max            : TButton;
    rot_zero           : TButton;

    Z_image            : TImage;
    Z_icon             : TImage;

    OK_btn             : TSpeedButton;
    Can_btn            : TSpeedButton;

    Load_btn           : TButton;
    Save_btn           : TButton;
    About_btn          : TButton;
    Kill_btn           : TButton;
    Panel1: TPanel;
    f_speed: TLabel;
    Label27: TLabel;
    Label35: TLabel;
    Label26: TLabel;
    Label36: TLabel;
    designed_speed: TLabel;
    Button1: TButton;
    fix_speed: TBorCheck;
    Label33: TLabel;
    pause_freeze: TBorRadio;
    pause_continue: TBorRadio;
    pause_mouse: TBorRadio;
    Set_speed: TButton;
    speed_scroll: TScrollBar;
    Mode_btn: TButton;
    Shape1: TShape;
    Shape2: TShape;
    Shape3: TShape;
    Shape4: TShape;
    Panel2: TPanel;
    Label1: TLabel;

    procedure Kill_btnClick(Sender: TObject);
    procedure OK_btnClick(Sender: TObject);
    procedure Can_btnClick(Sender: TObject);
    procedure Load_btnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure max_rot_speedScroll(Sender: TObject; ScrollCode: TScrollCode;
      var ScrollPos: Integer);
    procedure FormShow(Sender: TObject);
    procedure PDF_zeroClick(Sender: TObject);
    procedure fix_speedClick(Sender: TObject);
    procedure Set_speedClick(Sender: TObject);
    procedure speed_scrollChange(Sender: TObject);
    procedure Save_btnClick(Sender: TObject);
    procedure About_btnClick(Sender: TObject);
    procedure Mode_btnClick(Sender: TObject);
    procedure rot_zeroClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }
    just_loaded : boolean;
    procedure WriteText(var dest:TStringList;   aname:string);
    procedure ReadText (source:TStringList);
    function  GetPalette : hPalette; override;
  end;

var
  Settings_Form: TSettings_Form;

implementation

uses SettingsForm, OptionsForm, Main_window, LoadSaveForm, AboutForm;

{$R *.DFM}

{ ----------------------------------------------------------------------- }
{                           Load/Save settings                            }
{ ----------------------------------------------------------------------- }
procedure TSettings_Form.WriteText(var dest:TStringList; aname:string);
var lp1 : integer;
    TC  : TComponent;
begin
  if dest=nil then dest:=TStringList.Create;
  dest.Clear;
  dest.Add(aname);
  for lp1:=0 to ComponentCount-1 do begin
    TC := Components[lp1];
    if TC is TScrollBar then with TScrollBar(TC) do
      dest.Add(Format('%20s',[TC.name])+#9+IntToStr(min)+#9+IntToStr(max)+#9+IntToStr(position))
    else if TC is TBorRadio then
      dest.Add(Format('%20s',[TC.name])+#9+BoolToStr(TBorRadio(TC).checked))
    else if TC is TBorCheck then
      dest.Add(Format('%20s',[TC.name])+#9+BoolToStr(TBorCheck(TC).checked))
    else if TC is TListBox then with TListBox(TC) do if ItemIndex<>-1 then 
      dest.Add(Format('%20s',[TC.name])+#9+Items[ItemIndex])
  end;
end;

procedure TSettings_Form.ReadText(source:TStringList);
var lp1   : integer;
    TC    : TComponent;
    alist : TStringlist;
begin
  alist := TStringList.Create;
  for lp1:=1 to source.count-1 do begin
    alist := BreakString(source[lp1],alist);
    TC := findComponent(alist[0]);
    if TC is TScrollBar then with TScrollBar(TC) do begin
      min      := StrToInt(alist[1]);
      max      := StrToInt(alist[2]);
      position := StrToInt(alist[3]);
    end
    else if TC is TBorRadio then
      TBorRadio(TC).checked := alist[1]='TRUE'
    else if TC is TBorCheck then
      TBorCheck(TC).checked := alist[1]='TRUE'
    else if TC is TListBox then with TListBox(TC) do
      ItemIndex := Items.IndexOf(UpperCase(alist[1]))
    else if (tc<>nil) and (TC.name='designed_speed') then with TListBox(TC) do
      Caption := alist[1]
  end;
  f_speed.caption := IntToStr(0);
end;
{ ----------------------------------------------------------------------- }
{                             Event handlers                              }
{ ----------------------------------------------------------------------- }
procedure TSettings_Form.FormCreate(Sender: TObject);
begin
  palette_list.Items.Clear;
  find_all_palettes(TStringList(palette_list.Items));
  speed_scroll.Position := StrToInt(designed_speed.Caption);
end;

procedure TSettings_Form.FormShow(Sender: TObject);
begin
  CenterWindow(Handle);
  if palette_list.ItemIndex>=2 then
    sendmessage(palette_list.handle,LB_SetTopIndex,palette_list.ItemIndex-2,0)
  else
    sendmessage(palette_list.handle,LB_SetTopIndex,0,0);
  if Zonewindow.speed_ok then fix_speed.CheckColor := clGreen
  else fix_speed.CheckColor := clMaroon;
  just_loaded := false;
end;

procedure TSettings_Form.Kill_btnClick(Sender: TObject);
begin
  LoadSave_Form.CleanUp; // do it now before main window closes (looks nicer)
  Application.Mainform.close;
end;

procedure TSettings_Form.OK_btnClick(Sender: TObject);
begin
  ModalResult := mrOK;
end;

procedure TSettings_Form.Can_btnClick(Sender: TObject);
begin
  ModalResult := mrCancel;
end;

procedure TSettings_Form.Load_btnClick(Sender: TObject);
begin
  if LoadSave_Form.Load_setting=mrOK then just_loaded := true;
end;

procedure TSettings_Form.Save_btnClick(Sender: TObject);
begin
  LoadSave_Form.Save_setting;
end;

procedure TSettings_Form.max_rot_speedScroll(Sender: TObject;
  ScrollCode: TScrollCode; var ScrollPos: Integer);
begin
  if sender = max_rot_speed then if ScrollPos<min_rot_speed.position then
      ScrollPos:=min_rot_speed.position;
  if sender = min_rot_speed then if ScrollPos>max_rot_speed.position then
      ScrollPos:=max_rot_speed.position;
end;

procedure TSettings_Form.PDF_zeroClick(Sender: TObject);
var lp1 : integer;
    scr : TScrollbar;
begin
  for lp1:=1 to 10 do begin // scrollbars are wrong way round !
    scr := TScrollbar(FindComponent('density'+inttostr(lp1)));
    if sender=PDF_zero then scr.position:= scr.max
    else if sender=PDF_max then scr.position:= scr.min;
  end;
end;

function TSettings_Form.GetPalette : hPalette;
begin
  if hPalApp<>0 then result := hPalApp
  else result := inherited GetPalette;
end;

procedure TSettings_Form.fix_speedClick(Sender: TObject);
begin
  if fix_speed.checked then begin
    speed_scroll.Enabled   := false;
    Set_speed.Enabled := false;
  end else begin
    speed_scroll.Enabled   := true;
    Set_speed.Enabled := true;
  end;
end;

procedure TSettings_Form.Set_speedClick(Sender: TObject);
begin
  designed_speed.Caption := f_speed.Caption;
  speed_scroll.position := StrToInt(f_speed.Caption);
end;

procedure TSettings_Form.speed_scrollChange(Sender: TObject);
begin
  designed_speed.Caption := IntToStr(speed_scroll.Position);
end;

procedure TSettings_Form.About_btnClick(Sender: TObject);
begin
  About_Form.ShowModal;
end;

procedure TSettings_Form.Mode_btnClick(Sender: TObject);
begin
  Options_Form.Showmodal;
end;

procedure TSettings_Form.rot_zeroClick(Sender: TObject);
begin
  ampl.position          := ampl.min;
  freq.position          := 0;
  precess.position       := 0;
  max_rot_speed.position := 0;
  min_rot_speed.position := 0;
end;

procedure TSettings_Form.Button1Click(Sender: TObject);
begin
  palette_inc.position := 0;
  colour_step.position := 0;
end;                                         

procedure TSettings_Form.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key=VK_F1 then Application.HelpContext(0);
end;

end.
